#!/usr/local/bin/ruby
=begin
/****************************************************************
**
** Qt tutorial 6
**
****************************************************************/
=end
require "qt"
include Qt

class LCDRange < QWidget
def initialize parent

   @lcd = QLCDNumber.new( 2, self, "lcd"  )
   @lcd.move(0,0)
   @sBar = QScrollBar.new( 0, 99,		       	#// range
			   1, 10, 			#// line/page steps
			   0, 				#// inital value
			   QScrollBar::Horizontal, 	#// orientation
                           self, "scrollbar" )
   Qt::connect(@sBar,QSIGNAL("valueChanged(int)"),@lcd,QSLOT("display(int)"))
   catchEvent
end
def resizeEvent ev
   @sBar.setGeometry(0, height - 16, width, 16)
   @lcd.resize(width,@sBar.y - 5)
end
end

class MyWidget < QWidget
def initialize
   setMinimumSize(200, 300)
   @quit = QPushButton.new( "Quit", self, "quit" )
   @quit.setGeometry(   10, 10, 75, 30 )
   @quit.setFont(QFont.new(   "Times", 18, QFont::Bold ))
   Qt::connect(@quit, QSIGNAL("clicked()"),QApplication::qApp,QSLOT("quit()"))
   i = 0
   @value = []
   while i < 16
      @value[i]= LCDRange.new  self
      i = i + 1
   end
   catchEvent
end
def resizeEvent ev
   startx = 10
   starty = @quit.y + @quit.height + 10
   valueWidth = (width - startx - 10 - 3*5)/4
   valueHeight = (height - starty - 10 - 3*5)/4
   i = 0
   while i < 16
      @value[i].setGeometry( startx + (i%4)*(5+valueWidth),
			       starty + (i/4)*(5+valueHeight),
                               valueWidth, valueHeight )
      i = i + 1
   end
end
end

a = QApplication.new([$0] + ARGV)
w = MyWidget.new
w.setGeometry(100,100,400,400)
w.show
a.exec

