=begin
 /****************************************************************
**
** Implementation CannonField class, Qt tutorial 8
**
****************************************************************/
=end
# For rubyQt
require "qt"
include Qt

class CannonField < QWidget
def initialize(parent=nil,name="")
   @angleChanged = RSignal.new("int")  # signal with int
   @ang = 45
   catchEvent
end

def angleChanged
   @angleChanged
end

def setAngle degrees #slot
   if degrees < 5
      degrees = 5
   elsif degrees > 70
      degrees = 70
   elsif degrees == @ang
      return
   end
   @ang = degrees
   self.paintEvent(nil  )
   angleChanged.send_int(@ang)
end

def paintEvent ev
#   p = QPainter.new(nil)
   brush = QBrush.new(QColor.new(0,0,255))
   pen = QPen.new( QColor.new(255,255,255))
   pen.setStyle(NoPen)

   p = QPainter.new(self)
   p.setBrush(brush)
   p.setPen(pen)

   p.translate(0,height)
   eraseAll # This is necessary for rubyQt
   p.drawPie( -35, -35, 70, 70, 0, 90*16 )
   p.rotate( - @ang)
   p.drawRect( 33, -4, 15, 8 )

   p.end

end

end
