#!/usr/local/bin/ruby
require 'classtree.rb'
require 'qt'
#require 'gtk'
#include Gtk
#include Qt

class RClassMain < QMainWindow
def initialize
   @w0 = QWidget.new(self)
   @splitter = QSplitter.new(QSplitter::Vertical,@w0,"split1")
   @popup = QPopupMenu.new
   @popup.insertItem("&Qt",1)
   @popup.insertItem("&Gtk",2)
   @popup.insertItem("&Fltk",3)
   @popup.insertItem("&Tk",4)
   @popup.insertItem("&All",5)
   @popup.insertItemQObj( "&Quit", QApplication::qApp, QSLOT("quit()"), CTRL+Key_Q )
   menuBar.insertItem("&File",@popup)
   @classWindow = RClassView.new(@splitter)
   Qt::connect(menuBar,QSIGNAL("activated(int)"), self, "menuActivated")
   @edit = QMultiLineEdit.new(@splitter)
   setCentralWidget(@w0)
   Qt::connect(@classWindow.signal_mlist,self,"methodSelected")
   Qt::connect(@classWindow.signal_vlist,self,"constSelected")

   catchEvent
   setCaption("Ruby Class Browser")
   statusBar.message( "Ready", 5000 )
end
def menuActivated i
   case i
   when 1
      @classWindow.initialize_classview_qt
   when 2
      @classWindow.initialize_classview_gtk
   when 3
      @classWindow.initialize_classview_fltk
   when 4
      @classWindow.initialize_classview_tk
   when 5
      @classWindow.initialize_classview_Object
   end
end
def methodSelected str
   if str[0].chr == "-"
      @edit.clear
      @edit.setText("No method selected")
      return
   end
   str1 = "Selected Method is "
   str1 += str + " "
   str1 += " in " + "#{@classWindow.currentClass}"
   @edit.clear
   @edit.setText(str1)
end
def constSelected str
   str1 = str + " in " +  "#{@classWindow.currentClass} = "
   temp1 = eval("#{@classWindow.currentClass}::#{str}")
   str1 += temp1.to_s
   @edit.clear
   @edit.setText(str1)
end
def resizeEvent ev
      @splitter.resize(width,height)
end
end

class RClassView < QWidget
def initialize w
   @split = QSplitter.new(QSplitter::Horizontal,self,"split2")
   @classview = QListView.new(@split,"classview")
   @classview.addColumn("Ruby Class")
   @classview.setColumnWidthMode(1,QListView::Maximum)
   @classview.setRootIsDecorated( true )

   @w1 = QWidget.new(@split)
   @hblayout = QHBoxLayout.new(@w1)
   @vblayout1 = QVBoxLayout.new()
   @hblayout.addLayout(@vblayout1)

   @mlisthead = QLabel.new("Methods",@w1,"mlisthead")
   @mlisthead.setFrameStyle(QFrame::Panel | QFrame::Raised)
   @vblayout1.addWidget(@mlisthead)
   @methodlist = QListBox.new(@w1,"methodlist")
   @vblayout1.addWidget(@methodlist)
   @signal_mlist = RSignal.new("const char*")
   Qt::connect(@methodlist,QSIGNAL("selected(const char*)"),
             @signal_mlist)

   @vblayout2 = QVBoxLayout.new()  #
   @hblayout.addLayout(@vblayout2)

   @varlisthead = QLabel.new("Constants",@w1,"varlisthead")
   @varlisthead.setFrameStyle(QFrame::Panel | QFrame::Raised)
   @vblayout2.addWidget(@varlisthead)
   @varlist = QListBox.new(@w1,"varlist")
   @vblayout2.addWidget(@varlist)
   @signal_vlist = RSignal.new("const char*")
   Qt::connect(@varlist,QSIGNAL("selected(const char*)"),
            @signal_vlist)


   newheight = @classview.header.height - 10
   @mlisthead.setFixedHeight(newheight)
   @varlisthead.setFixedHeight(newheight)


   @hblayout.activate

   initialize_classview_qt
   Qt::connect(@classview,QSIGNAL("selectionChanged()"),self,"cb_select")

   catchEvent


end
def resizeEvent ev
   @split.resize(width,height)
end

def signal_mlist
   @signal_mlist
end
def signal_vlist
   @signal_vlist
end
def currentClass
   @classview.currentItem.text(0)
end
def currentMethod
   @methodlist.text(@methodlist.currentItem)
end
def currentConst
   @varlist.text(@varlist.currentItem)
end
def resizeEvent ev
   @split.resize(width,height)
end

def initialize_classview_qt
   @classview.clear
   @classtree = ClassTree.new(["Qt"])
   @classtree.createTree(@classview)
#   @classtree.createConstantslist(@varlist)
#   @classtree.createMethodsList(@methodlist)
end

def initialize_classview_gtk
   require "gtk"
   @classview.clear
   @classtree = ClassTree.new(["Gdk","Gtk"])
   @classtree.createTree(@classview)
end
def initialize_classview_fltk
   require "fltk"
   @classview.clear
   @classtree = ClassTree.new(["Fltk"])
   @classtree.createTree(@classview)
   # $walker.visit(initialize_args({"fltk" => ["Fltk"]}))
   # $walker.createDescendantsTree(@classview)
   # $walker.createConstantsList(@varlist,nil)
   # $walker.createMethodsList(@methodlist, nil)
end
def initialize_classview_tk
    require "tk"
   @classview.clear
   @classtree = ClassTree.new(["Tk","TkKernel"])
   @classtree.createTree(@classview)
   # $walker.clear
   # $walker.visit(initialize_args({"tk" => ["Tk"]}))
   # $walker.createDescendantsTree(@classview)
   # $walker.createConstantsList(@varlist,nil)
   # $walker.createMethodsList(@methodlist, nil)
end
def initialize_classview_Object
   @classview.clear
   @classtree = ClassTree.new(["Object"])
   @classtree.createTree(@classview)
   # $walker.clear
   # $walker.visit(initialize_args({"tk" => ["Tk"]}))
   # $walker.createDescendantsTree(@classview)
   # $walker.createConstantsList(@varlist,nil)
   # $walker.createMethodsList(@methodlist, nil)
end
def cb_select
   cname = @classview.currentItem.text(0)
      @classtree.changeConstants(@varlist,cname)
      @varlisthead.setText("Constants:" + cname)
      @classtree.changeMethods(@methodlist,cname)
      @mlisthead.setText("Methods:" + cname)
   # $walker.changeConstants(@varlist,cls)
   # $walker.changeMethods(@methodlist,cls)
end
end


a = QApplication.new( [$0] + ARGV)
#QApplication::setStyle(Qt::WindowsStyle)
w = RClassMain.new
a.setMainWidget(w)

w.show
a.exec
