=begin
/****************************************************************************
** $Id: connect.rb,v 1.1.1.1 2000/09/19 07:56:09 horie Exp $
**
** Copyright (C) 1992-1998 Troll Tech AS.  All rights reserved.
**
** This file is part of an example program for Qt.  This example
** program may be used, distributed and modified without limitation.
**
*****************************************************************************/
=end

require "qt"
include Qt

MAXPOINTS = 2000;			#// maximum number of points
MAXCOLORS = 40;


#//
#// ConnectWidget - draws connected lines
#//

class ConnectWidget < QWidget


#//
#// Constructs a ConnectWidget.
#//

def initialize #( parent, name )

    setBackgroundColor( QColor("white") );		#// white background
    @count = 0;
    @down = FALSE;
    @points = []
    @colors = []
    for i in 0..MAXCOLORS		#// init color array
	@colors[i] = QColor.new( rand(100)/100.0*255, rand(100)/100.0*255, rand(100)/100.0*255 );
    end
    @paint = QPainter.new( self );
    catchEvent
end

#//
#// Handles paint events for the connect widget.
#//

def paintEvent ev

#    paint = QPainter.new( self );
    for i in 0..(@count - 2)		#// connect all points
	for j in (i + 1)..(@count - 1)
	   @paint.setPenQColor( @colors[rand(100)%MAXCOLORS] ); #// set random pen color
	   @paint.drawLineQPoint( @points[i], @points[j] ); #// draw line
 	end
    end
end


#//
#// Handles mouse press events for the connect widget.
#//

def mousePressEvent ev

    @down = TRUE;
    @count = 0;					#// start recording points
    eraseAll();					#// erase widget contents
end


#//
#// Handles mouse release events for the connect widget.
#//

def mouseReleaseEvent ev

    @down = FALSE;				#// done recording points
    updateAll();					#// draw the lines
end


#//
#// Handles mouse move events for the connect widget.
#//

def mouseMoveEvent e

    if ( @down && @count < MAXPOINTS )
	#paint = QPainter.new( self );
 	@points[@count] = QPoint.new(e.pos.x,e.pos.y);		#// add point
        @count = @count + 1;
	@paint.drawPointQPoint( e.pos );		#// plot point
    end
end

end
#//
#// Create and display a ConnectWidget.
#//


    a = QApplication.new( [$0] + ARGV );
    connect = ConnectWidget.new
    a.setMainWidget( connect );
    connect.show();
    a.exec();

