=begin
/****************************************************************************
** $Id: cursor.rb,v 1.1.1.1 2000/09/19 07:56:09 horie Exp $
**
** Copyright (C) 1992-1998 Troll Tech AS.  All rights reserved.
**
** This file is part of an example program for Qt.  This example
** program may be used, distributed and modified without limitation.
**
*****************************************************************************/
=end

require "qt"
include Qt

#// cb_bits and cm_bits were generated by X bitmap program.

Cb_width  = 32
Cb_height = 32
#// cursor bitmap
Cb_bits = [		
   0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xf8, 0x0f, 0x00,
   0x00, 0x06, 0x30, 0x00, 0x80, 0x01, 0xc0, 0x00, 0x40, 0x00, 0x00, 0x01,
   0x20, 0x00, 0x00, 0x02, 0x10, 0x00, 0x00, 0x04, 0x08, 0x3e, 0x3e, 0x08,
   0x08, 0x03, 0xe0, 0x08, 0xc4, 0x00, 0x00, 0x11, 0x04, 0x1e, 0x78, 0x10,
   0x02, 0x0c, 0x30, 0x20, 0x02, 0x40, 0x00, 0x20, 0x02, 0x40, 0x00, 0x20,
   0x02, 0x40, 0x00, 0x20, 0x02, 0x20, 0x04, 0x20, 0x02, 0x20, 0x04, 0x20,
   0x02, 0x10, 0x08, 0x20, 0x02, 0x08, 0x08, 0x20, 0x02, 0xf0, 0x07, 0x20,
   0x04, 0x00, 0x00, 0x10, 0x04, 0x00, 0x00, 0x10, 0x08, 0x00, 0xc0, 0x08,
   0x08, 0x3c, 0x30, 0x08, 0x10, 0xe6, 0x19, 0x04, 0x20, 0x00, 0x0f, 0x02,
   0x40, 0x00, 0x00, 0x01, 0x80, 0x01, 0xc0, 0x00, 0x00, 0x06, 0x30, 0x00,
   0x00, 0xf8, 0x0f, 0x00, 0x00, 0x00, 0x00, 0x00 ]

Cm_width = 32
Cm_height = 32
#// cursor bitmap mask
Cm_bits = [		
   0x00, 0x00, 0x00, 0x00, 0x00, 0xf8, 0x1f, 0x00, 0x00, 0xfe, 0x3f, 0x00,
   0x80, 0x07, 0xf0, 0x00, 0xc0, 0x01, 0xc0, 0x01, 0x60, 0x00, 0x00, 0x03,
   0x30, 0x00, 0x00, 0x06, 0x18, 0x00, 0x00, 0x0c, 0x0c, 0x3e, 0x3e, 0x18,
   0x0e, 0x03, 0xe0, 0x18, 0xc6, 0x00, 0x00, 0x31, 0x07, 0x1e, 0x78, 0x30,
   0x03, 0x0c, 0x30, 0x60, 0x03, 0x40, 0x00, 0x60, 0x03, 0x40, 0x00, 0x60,
   0x03, 0x40, 0x00, 0x60, 0x03, 0x20, 0x04, 0x60, 0x03, 0x20, 0x04, 0x60,
   0x03, 0x10, 0x08, 0x60, 0x03, 0x08, 0x08, 0x60, 0x03, 0xf0, 0x07, 0x60,
   0x06, 0x00, 0x00, 0x30, 0x06, 0x00, 0x00, 0x30, 0x0c, 0x00, 0xc0, 0x18,
   0x0c, 0x3c, 0x30, 0x18, 0x18, 0xe6, 0x19, 0x0c, 0x30, 0x00, 0x0f, 0x06,
   0x60, 0x00, 0x00, 0x03, 0xc0, 0x01, 0xc0, 0x01, 0x80, 0x07, 0xf0, 0x00,
   0x00, 0xfe, 0x3f, 0x00, 0x00, 0xf8, 0x0f, 0x00 ]

#//
#// The CursorView contains many labels with different cursors.
#//
class Cursor
def initialize cursor, name
   @qcursor = cursor
   @name = name
end
def cursor
   @qcursor
end
def name
   @name
end
end

class CursorView < QWidget		#// cursor view
#//
#// Constructs a cursor view.
#//

def initialize			#// construct view


     list = [
	Cursor.new(QCursor.new(ArrowCursor),	"arrowCursor"),
	Cursor.new(QCursor.new(UpArrowCursor),	"upArrowCursor" ),
	Cursor.new(QCursor.new(CrossCursor),	"crossCursor" ),
	Cursor.new(QCursor.new(WaitCursor),	"waitCursor" ),
	Cursor.new(QCursor.new(IbeamCursor),	"ibeamCursor" ),
	Cursor.new(QCursor.new(SizeVerCursor),	"sizeVerCursor" ),
	Cursor.new(QCursor.new(SizeHorCursor),	"sizeHorCursor" ),
	Cursor.new(QCursor.new(SizeBDiagCursor),	"sizeBDiagCursor" ),
	Cursor.new(QCursor.new(SizeFDiagCursor),	"sizeFDiagCursor" ),
	Cursor.new(QCursor.new(SizeAllCursor),	"sizeAllCursor" ),
	Cursor.new(nil,				"") ];

    setCaption( "CursorView" );			#// set window caption

    i=0;
    for y in 0..1 			#// create 10 small labels
	for x in 0..4
	    label = QLabel.new("", self );
	    label.setCursor( list[i].cursor );
	    label.setText( list[i].name );
	    label.setAlignment( AlignCenter );
	    label.setFrameStyle( QFrame::Box | QFrame::Raised );
	    label.setGeometry( 10+x*110, 10+y*50, 100, 40 );
	    i = i+1;
	end
    end
    @cb = QBitmap.new( Cb_width, Cb_height, Cb_bits, true );
    @cm = QBitmap.new( Cm_width, Cm_height, Cm_bits, true );
    @custom = QCursor.new( @cb, @cm );			#// create bitmap cursor

    label = QLabel.new("", self );			#// create the big label
    label.setCursor( @custom );
    label.setText( "Custom bitmap cursor" );
    label.setAlignment( AlignCenter );
    label.setFrameStyle( QFrame::Box | QFrame::Sunken );
    label.setGeometry( 10, 110, 540, 40 );
    resize( 20+5*110, 20+3*50 );
end

end

#//
#// Create and display a CursorView.
#//

    a = QApplication.new( [$0] + ARGV );		#// application object
    v = CursorView.new;				#// cursor view
    a.setMainWidget( v );
    v.show();
    a.exec();

