=begin
/****************************************************************************
** $Id: forever2.rb,v 1.1.1.1 2000/09/19 07:56:09 horie Exp $
**
** Copyright (C) 1992-1998 Troll Tech AS.  All rights reserved.
**
** This file is part of an example program for Qt.  This example
** program may be used, distributed and modified without limitation.
**
*****************************************************************************/
=end

require "qt"
include Qt

$COLORS = 120				#// number of colors to use
$number = 0                             # PInt class is replace global variable
					# It's faster than PInt class!


#//
#// Counter - a widget that displays an unsigned int continuously.
#//

class Counter < QLabel
#//
#// Constructs a Counter
#//

def initialize text

    setText( "  0  rectangles/second" );
    setAutoResize( true );			#// resize to fit the contents
    startTimer( 1000 );				#// one second timeout
    catchEvent
end
#//
#// Timer event is called every second and prints out number
#//

def timerEvent ev

    if ( $number != 0 )
	s = "#{$number} rectangles/second";
	setText( s );
	$number = 0;
    end
    repaintAll( TRUE );
end


end
#//
#// Forever - a widget that draws rectangles forever.
#//

class Forever < QWidget

#//
#// Constructs a Forever widget.
#//

def initialize ( parent=nil, name="" )
    #super ( parent, name )
     @colors = []
    for a in 0..( $COLORS -1 )
	@colors[a] = QColor.new( rand( 255),rand( 255),rand( 255) );
    end
    $number = 0
    @counter = Counter.new("");			#// counter in its own window
    @counter.show();				#// show the counter
    startTimer( 0 );				#// run continuous timer
    @paint = QPainter.new( self );
    catchEvent
end

#//
#// Handles paint events for the Forever widget.
#//

def paintEvent ev

    #paint = QPainter.new( self );		#// painter object
    @paint.setWindow( 0, 0, 1024, 1024 );	#// define coordinate system
    @paint.setPenStyle( NoPen );			#// do not draw outline
    @paint.setBrushQColor( @colors[rand $COLORS]);	#// set random brush color
    p1 = QPoint.new( rand( 1023), rand( 1023) );	#// p1 = top left
    p2 = QPoint.new( rand( 1023), rand( 1023) );	#// p2 = bottom right
    r = QRect.new( p1.x,p1.y, p2.x,p2.y );
    @paint.drawRectQRect( r );			#// draw filled rectangle
end

#//
#// Handles timer events for the Forever widget.
#//

def timerEvent env

    repaintAll( FALSE );				#// repaint, don't erase
    $number += 1;
end

end
#//
#// Create and display Forever widget.
#//

    a = QApplication.new( [$0]+ARGV );		#// create application object
    always = Forever.new				#// create widget
    a.setMainWidget( always );			#// set as main widget
    always.show();				#// show widget
    a.exec();				#// run event loop

