=begin
/****************************************************************************
** $Id: hello_lib.rb,v 1.1.1.1 2000/09/19 07:56:09 horie Exp $
**
** Copyright (C) 1992-1998 Troll Tech AS.  All rights reserved.
**
** This file is part of an example program for Qt.  This example
** program may be used, distributed and modified without limitation.
**
*****************************************************************************/
=end
require "qt"
include Qt
=begin
/*
  Constructs a Hello widget. Starts a 40 ms animation timer.
*/
=end
class Hello < QWidget
def initialize
   @b = 0
   @t = ""
   @timer = QTimer.new(self)
   Qt::connect(@timer, QSIGNAL("timeout()"),self,"animate")
   @timer.start(40)
   resize(200,100)
   @clicked = RSignal.new("")
#   Qt::connect(@clicked,self,QSIGNAL("clicked()"))
   catchEvent
end
def setText s
   @t = s
end
def clicked
   @clicked
end
=begin
/*
  This private slot is called each time the timer fires.
*/
=end

def animate
    @b = (@b + 1) & 15
    repaintAll( FALSE )
end

=begin
/*
  Handles mouse button release events for the Hello widget.

  We emit the clicked() signal when the mouse is released inside
  the widget.
*/
=end
def mouseReleaseEvent e

    if ( rect().contains( e.pos() ) )
	@clicked.send
    end
end

=begin
/*
  Handles paint events for the Hello widget.

  Flicker-free update. The text is first drawn in the pixmap and the
  pixmap is then blt'ed to the screen.
*/
=end
def paintEvent e

    sin_tbl = [
	0, 38, 71, 92, 100, 92, 71, 38,	0, -38, -71, -92, -100, -92, -71, -38]

    if ( @t.size == 0 )
	return
    end
    #// 1: Compute some sizes, positions etc.
    fm = fontMetrics
    w = fm.width(@t) + 20;
    h = fm.height() * 2;
    pmx = width()/2 - w/2;
    pmy = height()/2 - h/2;

    #// 2: Create the pixmap and fill it with the widget's background
    pm = QPixmap.new( QSize.new(w, h) )
    pm.fillQWidget( self, pmx, pmy )

    #// 3: Paint the pixmap. Cool wave effect
    p = QPainter.new(pm)
    x = 10
    y = h/2 + fm.descent
    i = 0
 #   p.begin( pm )
    p.setFont( font )
    while ( @t[i] )
	i16 = (@b+i) & 15
        p.setPen( QPen.new(QColor.new((15-i16)*16,255,255,QColor::Hsv)) )
	p.drawText( x, y - sin_tbl[i16]*h/800, @t[i].chr, 1 )
	x += fm.width( @t[i].chr )
	i = i + 1
    end
    p.end()

    bitBlt( self, pmx, pmy, pm )
end
end

