#!/usr/local/bin/ruby
=begin
/****************************************************************************
** $Id: aclock_lib.rb,v 1.1.1.1 2000/09/19 07:56:09 horie Exp $
**
** Copyright (C) 1992-1998 Troll Tech AS.  All rights reserved.
**
** This file is part of an example program for Qt.  This example
** program may be used, distributed and modified without limitation.
**
*****************************************************************************/
=end
# For rubyQt
require "qt"
include Qt

#//
#// Constructs an analog clock widget that uses an internal QTimer.
#//

class AnalogClock < QWidget
def initialize w
    @time = QTime::currentTime		#// get current time
    @internalTimer = QTimer.new( self ) 	#// create internal timer
print @internalTimer.type; print ":"; print @internalTimer.is_a?(QObject)
print "\n"
#    QRObject::connect_rslot( @internalTimer, QSIGNAL("timeout()"),
#        self, "timeout" )
    Qt::connect(@internalTimer, QSIGNAL("timeout()"),self,"timeout")
    @internalTimer.start( 500 )		#// emit signal every .5 seconds
    @paint = QPainter.new(self)
    catchEvent
end


#//
#// The QTimer::timeout() signal is received by this slot.
#//

def timeout

    new_time = QTime::currentTime()	#// get the current time
    if ( new_time.second != @time.second )	#// minute has changed
	updateAll
    end
end


#//
#// The clock is painted using a 1000x1000 square coordinate system.
#//

def paintEvent ev	#// paint clock

    if ( !isVisible )				#// is is invisible
	return
    end
    @time = QTime::currentTime()		#// save current time

#    pts = QPointArray.new
#   paint = QPainter.new(self)
#   @paint.setBrushQColor( backgroundColor )
    @paint.setBrushQColor( QColor("black"))     #// fill with foreground color


    cp = rect.center
    if (width >= height)
       d = height
    else
       d = width
    end
				#// widget center point
#    d = QMIN(width,height)			#// we want a circular clock

    matrix = QWMatrix.new;				#// setup transformation matrix
    matrix.translate( cp.x(), cp.y() )		#// origin at widget center
    matrix.scale( d / 1000.0, d / 1000.0 )	#// scale coordinate system

    h_angle = 30*(@time.hour % 12 - 3) + @time.minute / 2
    matrix.rotate( h_angle )			#// rotate to draw hour hand
    @paint.setWorldMatrix( matrix )
    pts = QPointArray.new
#    pts.setPoints( 4,-20,0,0,-20, 300,0, 0,20 )
#    pts.setPointQPoint(1,QPoint.new(-20,0))
     pts.resize(4)
    pts.setPoint(0,-20,0)
    pts.setPoint(1,0,-20)
    pts.setPoint(2,300,0)
    pts.setPoint(3,0,20)
    @paint.drawPolygon( pts )
#    @paint.drawLine(0,0,300,0)			#// draw hour hand
    matrix.rotate( -h_angle )			#// rotate back to zero

    m_angle = (@time.minute - 15) * 6
    matrix.rotate( m_angle )			#// rotate to draw minute hand
    @paint.setWorldMatrix( matrix )
#    pts.setPoints( 4, -10,0, 0,-10, 400,0, 0,10 )
    pts.setPoint(0, -10,0)
    pts.setPoint(1, 0, -10)
    pts.setPoint(2,400,0)
    pts.setPoint(3,0,10)
    @paint.drawPolygon( pts )
#    @paint.drawLine(0,0,400,0)			#// draw minute hand
    matrix.rotate( -m_angle )                   #// rotate back to zero

    m_angle = (@time.second - 15) * 6
    matrix.rotate( m_angle )			#// rotate to draw minute hand
    @paint.setWorldMatrix( matrix )			
    @paint.setPenQColor( QColor("red"))
    @paint.drawLine(0,0,400,0)			#// draw minute hand
    matrix.rotate( -m_angle )
    @paint.setPenQColor( QColor("black"))

    for i in 0..12 		#// draw hour lines
	@paint.setWorldMatrix( matrix )
	@paint.drawLine( 450,0, 500,0 )
	matrix.rotate( 30 )
    end
end

end

